select
  an.numero
  , (case when (lac.dtfim is null) then 'Em lactao' else 'Seca' end) as status_produtivo
  , (case when ((evant.cdreproducao is null) or (evant.cdtiporeproducao = 7)) then 'x' else null end) as primeira_tentativa
  , tent.data as data_tentativa
  , (case tent.cdtiporeproducao when 1 then 'Inseminao' when 2 then 'Cobertura' when 3 then 'Implante' else '' end) as tipo_tentativa
  , (case when (evant.cdreproducao is not null) then (tent.data - evant.data) else null end) as intervalo
  , (case when (diag.diagnostico = 'P') then 'P' when (((diag.cdtiporeproducao in (1,2,3,4)) and (diag.diagnostico is null)) or (diag.diagnostico = 'N'))
        then 'N' else '' end) as diagnostico
from
  animal an
  join lactacao lac on lac.cdlactacao =
    (select first 1 re.cdlactacao from lactacao re where re.cdanimal = an.cdanimal order by re.dtinicio desc)
  join reproducao tent on tent.cdanimal = an.cdanimal and tent.cdtiporeproducao in (1,2,3) and tent.data > lac.dtinicio
  left join reproducao evant on evant.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = tent.cdanimal and re.cdtiporeproducao in (1,2,3,7)
        and re.data < tent.data order by re.data desc)
  left join reproducao diag on diag.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = tent.cdanimal and re.data > tent.data and
        ((re.cdtiporeproducao in (1,2,3,7)) or (re.cio in (1,2)) or (re.diagnostico is not null)) order by re.data asc)
where
  an.dtbaixa is null
order by
  an.numordenado, tent.data
